#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define TRUE	-1
#define FALSE	0

char	acSpinny[4] = {0x7c,0x2f,0x2d,0x5c};

void DoSpinny(void)
{
	static int	iPos = 0;

	printf("\b%c",acSpinny[iPos]);
	iPos++;
	if ( iPos == 4 )	iPos = 0;
}

void main(int argc, char **argv)
{
	FILE	*fMainFile, *fPatchFile;
	int		iApplyPatch = 1;
	int		iByte, iOldByte, iNewByte;
	long	lFileOffset;

	if ( argc < 3 )
	{
		printf("Format is BINPATCH <program name > <patch filename> <1 = on | 0 = off>\n");
		return;
	}

	fMainFile = fopen( argv[1], "r+b");

	if ( fMainFile == NULL )
	{
		printf("Unable to open file <%s>\n", argv[1]);
		return;
	}

	fPatchFile = fopen( argv[2],"r");

	if ( fPatchFile == NULL )
	{
		printf("Can't find the patch file <%s>\n", argv[2]);
		fclose(fMainFile);
		return;
	}

	if ( argc == 4 )
	{
		iApplyPatch = atoi(argv[3]);
	}

	if ( iApplyPatch )
	{
		printf("Applying swap file <%s> to file <%s>\n", argv[2], argv[1]);
	}
	else
	{
		printf("Reversing swap file <%s> on file <%s>\n", argv[2], argv[1]);
	}

	printf("\nValidating file to patch against patch data..-");
	while ( !feof( fPatchFile ) )
	{
		fscanf( fPatchFile,"%ld,%d,%d\n", &lFileOffset, &iOldByte, &iNewByte );

		fseek( fMainFile, lFileOffset, SEEK_SET );
		iByte = fgetc( fMainFile );

		if ( iApplyPatch )
		{
			//	Compare the value in the main file with the old byte read in
			//	from the patch file at the appropriate offset
			if ( iByte != iOldByte )
			{
				printf("Main file does not contain the patch file starting data.\n");
				fclose(fMainFile);
				fclose(fPatchFile);
				return;
			}
		}
		else
		{
			//	Compare the value in the main file with the new byte read in
			//	from the patch file at the appropriate offset
			if ( iByte != iNewByte )
			{
				printf("Main file does not contain the patch file data.\n");
				fclose(fMainFile);
				fclose(fPatchFile);
				return;
			}
		}
		
		DoSpinny();
	}

	fseek( fPatchFile, 0l, SEEK_SET );
	printf("\nApplying patch file to main data file..-");
	while ( !feof( fPatchFile ) )
	{
		fscanf( fPatchFile,"%ld,%d,%d\n", &lFileOffset, &iOldByte, &iNewByte );

		fseek( fMainFile, lFileOffset, SEEK_SET );
		if ( iApplyPatch )
		{
			fputc( iNewByte, fMainFile );
		}
		else
		{
			fputc( iOldByte, fMainFile );
		}

		DoSpinny();
	}

	fclose( fMainFile );
	fclose( fPatchFile );
}
